<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
session_start();

require_once ("./constants.php");
require_once (ROOT_PATH . "/lang/" . $language . "/image.php");
require_once (ROOT_PATH . "/includes/functions.php");
require_once (ROOT_PATH . PHP_PATH . "/global.php");

$data          =$_REQUEST;
$data['action']=isset($data['action']) ? $data['action'] : 'search';

switch ($data['action'])
    {
    case "search":
        $data['term']         =isset($data['term']) ? $data['term'] : '';

        $data['field']        =isset($data['field']) ? $data['field'] : 'keywords';
        $data['cat']          =isset($data['cat']) ? $data['cat'] : 'all';
        $data['orient']       =isset($data['orient']) ? $data['orient'] : 'all';
        $data['user']         =isset($data['user']) ? $data['user'] : '';
        $data['termx']        =isset($data['termx']) ? $data['termx'] : '';
        $data['sortby']       =isset($data['sortby']) ? $data['sortby'] : 'newest';
        $data['rows_per_page']=isset($data['rows_per_page']) ? $data['rows_per_page'] : '5';
        $data['requestpage']  =isset($data['requestpage']) ? $data['requestpage'] : '1';
        $searchcat            =listCategories(1, 0, $data['cat'], 1);
        $result               =$GLOBALS['imageService']->search($data);
        $description          =$result['des'];
        $navigation           =$result['nav'];
        $images               =$result['images'];
        $hashlist             ='';

        if (checkPermission("lightbox"))
            {
            $hashlist=$GLOBALS['lightboxService']->searchNames();
            }

        include_once (ROOT_PATH . TEMPLATES_PATH . "/header.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/home.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/footer.htm");
        break;

    case "match_user":
        $users=$GLOBALS['userService']->matchUser($data['prefix']);

        header ('content-type:text/xml;charset=' . $lang['encoding']);
        echo $users;
        break;

    case "view":
        $GLOBALS['imageService']->incHits($data['id']);

        header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=detail&id=" . $data['id']."&errInfo=");
        break;

    case "detail":
        $image   =$GLOBALS['imageService']->searchById($data['id']);

        $comments=$GLOBALS['commentService']->searchByImageId($data['id']);
        include_once (ROOT_PATH . TEMPLATES_PATH . "/header.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/detail.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/footer.htm");
        break;

    case "register":
        $err =false;

        $flag=false;

        if (array_key_exists('update', $data))
            {
            $error=$GLOBALS['userService']->checkAccountAddForm($data);

            if (!empty($error))
                {
                foreach ($error as $index => $val)
                    {
                    $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                    }

                $err    =true;
                $errInfo=create_errinfo('red', $lang['account_register_error']);
                }
            else
                {
                $flag=$GLOBALS['userService']->register($data);

                if ($flag)
                    {
                    $errInfo=create_errinfo('green', $lang['account_register_success']);
                    }
                else
                    {
                    $errInfo=create_errinfo('red', $lang['account_register_error']);
                    }
                }
            }

        if ($flag)
            {
            header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=login");
            }
        else
            {
            include_once (ROOT_PATH . TEMPLATES_PATH . "/header.htm");
            include_once (ROOT_PATH . TEMPLATES_PATH . "/register.htm");
            include_once (ROOT_PATH . TEMPLATES_PATH . "/footer.htm");
            }

        break;

    case "check_name":
        $flag=$GLOBALS['userService']->existName($data['name']);

        echo $flag;
        break;

    case "edit_account":
        $err =false;

        $flag=false;

        if (array_key_exists('update', $data))
            {
            if ($data['type'] == 'info')
                {
                $error=$GLOBALS['userService']->checkAccountInfoUpdateForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['account_edit_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['userService']->updateAccount($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['account_edit_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['account_edit_error']);
                        }
                    }
                }
            else //password
                {
                $error=$GLOBALS['userService']->checkAccountPassUpdateForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['account_edit_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['userService']->updatePassword($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['account_edit_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['account_edit_error']);
                        }
                    }
                }
            }

        $user=$GLOBALS['userService']->searchById($data['id']);

        include_once (ROOT_PATH . TEMPLATES_PATH . "/header.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/account.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/footer.htm");
        break;

    case "login":
        $err =false;

        $flag=false;

        if (array_key_exists('validate', $data))
            {
            $error=$GLOBALS['userService']->checkLoginForm($data);

            if (!empty($error))
                {
                foreach ($error as $index => $val)
                    {
                    $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                    }

                $err    =true;
                $errInfo=create_errinfo('red', $lang['login_error']);
                }
            else
                {
                $flag=$GLOBALS['userService']->validate($data);

                if ($flag)
                    {
                    $errInfo=create_errinfo('green', $lang['login_success']);
                    }
                else
                    {
                    $errInfo=create_errinfo('red', $lang['login_error']);
                    }
                }
            }

        if ($flag)
            {
            if ($data['forward'] == 'list_lightbox')
                {
                header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=list_lightbox");
                }
            elseif ($data['forward'] == 'edit_account')
                {
                header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=edit_account&id=" . $_SESSION['userId']);
                }
            elseif ($data['forward'] == 'admin')
                {
                header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?t=admin");
                }
            else
                {
                header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=search");
                }
            }
        else
            {
            include_once (ROOT_PATH . TEMPLATES_PATH . "/header.htm");
            include_once (ROOT_PATH . TEMPLATES_PATH . "/login.htm");
            include_once (ROOT_PATH . TEMPLATES_PATH . "/footer.htm");
            }

        break;

    case "logout":
        $GLOBALS['userService']->logout();

        header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=login");
        break;

    case "genvalidate":
        $GLOBALS['userService']->genValCode();

        break;

    case "download":
        $GLOBALS['imageService']->incDownloads($data['id']);

        $GLOBALS['imageService']->download($data['id'], $data['size'], 0);
        break;

    case "rate":
        $GLOBALS['imageService']->rating($data);

        header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=detail&id=" . $data['id']);
        break;

    case "post":
            $err =false;

            $flag=false;

            if (array_key_exists('post', $data))
                {
                $error=$GLOBALS['commentService']->checkPostForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['detail_post_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['commentService']->save($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['detail_post_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['detail_post_error']);
                        }
                    }
                }

        header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=detail&id=" . $data['id']."&errInfo=".$errInfo);
        break;

    case "list_lightbox":
        $result      =$GLOBALS['lightboxService']->search($data['id']);

        $hashlist    =$result['hashlist'];
        $active      =$result['active'];
        $images      =$result['images'];
        $infoHashlist=$GLOBALS['lightboxService']->getInfo();
        include_once (ROOT_PATH . TEMPLATES_PATH . "/header.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/lightbox.htm");
        include_once (ROOT_PATH . TEMPLATES_PATH . "/footer.htm");
        break;

    case "copy_to_lightbox":
        $GLOBALS['lightboxService']->copy_to_lightbox($data['lightbox_id'], $data['photo_ids']);

        break;

    case "remove_from_lightbox":
        $GLOBALS['lightboxService']->remove_from_lightbox($data['lightbox_id'], $data['photo_ids']);

        break;

    case "create_lightbox":
        $GLOBALS['lightboxService']->create_lightbox($data['lightbox_name']);

        break;

    case "rename_lightbox":
        $GLOBALS['lightboxService']->rename_lightbox($data['lightbox_id'], $data['new_name']);

        break;

    case "delete_lightbox":
        $GLOBALS['lightboxService']->delete_lightbox($data['lightbox_id']);

        break;

    default:
        header ("Location:" . ROOT_PATH . PHP_PATH . "image.php?action=search");

        break;
    }
?>